%define brcmname netxtreme2
%define brcmvers 6.2.23

%define debug_package %{nil}

Summary  : Broadcom NetXtreme II iSCSI, 1-Gigabit and 10-Gigabit ethernet drivers
Name     : %{brcmname}
Version  : %{brcmvers}
Release  : 1
Vendor   : Broadcom Corporation
License  : GPL
Group    : System Environment/Base
Source   : %{brcmname}-%{brcmvers}.tar.bz2
BuildRoot: /var/tmp/%{brcmname}-buildroot

%description
This package contains the Broadcom NetXtreme II iSCSI (bnx2i), 1-Gigabit (bnx2) and 10-Gigabit (bnx2x) ethernet drivers.

%prep
%setup -n %{brcmname}-%{brcmvers} -T -b 0

%build
if [ -n "%{?KVER}" ]; then
	KVER=%{?KVER}
elif [ -n "${BUILD_KERNEL}" ]; then
	KVER=${BUILD_KERNEL}
else
	KVER=$(uname -r)
fi
make KVER=$KVER

%install
if [ -n "%{?KVER}" ]; then
	KVER=%{?KVER}
elif [ -n "${BUILD_KERNEL}" ]; then
	KVER=${BUILD_KERNEL}
else
	KVER=$(uname -r)
fi

BCM_KVER=`echo $KVER | cut -c1-3 | sed 's/2\.[56]/2\.6/'`
if [ "$BCM_KVER" = "2.6" ]; then
	BCM_EXT=ko
else
	BCM_EXT=o
fi

LINUXSRC=/lib/modules/$KVER

if [ -f $LINUXSRC/source/include/linux/version.h ]; then
   LINUXSRC=/lib/modules/$KVER/source/include/linux/version.h
else
	if [ -f $LINUXSRC/build/include/linux/version.h ]; then
	      LINUXSRC=/lib/modules/$KVER/build/include/linux/version.h
	else
		LINUXSRC=""
    	fi
fi

if [ $LINUXSRC }; then
   if [ `grep RHEL $LINUXSRC` ]; then
      BRCMMAJVER=`grep MAJOR $(LINUXSRC)/include/linux/version.h | sed -e 's/.*MAJOR \([0-9]\)/\1/'`
      BRCMINVER= `grep MINOR $(LINUXSRC)/include/linux/version.h | sed -e 's/.*MINOR \([0-9]\)/\1/'`
      if [ $BRCMMAJVER -eq 5 ]; then
      	 if [ $BRCMMINVER -gt 3]; then
      	    BCM_CNIC="1"
	    BCM_SCSI="1"
      	 fi
      fi	
      if [ $BRCMMAJVER -eq 6 ]; then
      	 BCM_CNIC="1"
      	 BCM_SCSI="1"
      fi 
   else
	if [ ! `grep SLE $LINUXSRC` ]; then
		BCM_CNIC="1"
		BCM_SCSI="1"
	fi
   fi
else
	if [ -f /etc/redhat-release ]; then
	   BRCMMAJVER=`sed -e 's/.*release \([0-9]\).*/\1/' /etc/redhat-release`
	   if [ $BRCMMAJVER -eq 5 ]; then
	      BRCMMINVER=`sed -e 's/.*\.\([0-9]\)*.*/\1/' /etc/redhat-release`
		if [ $BRCMMINVER -gt 3 ]; then
			BCM_CNIC="1"
			BCM_SCSI="1"
		fi
	   fi
	   if [ $BRCMMAJVER -eq 6 ]; then
	      BCM_CNIC="1"
	      BCM_SCSI="1"
	   fi
	fi
fi

if [ -f /etc/SuSE-release ]; then
	BRCMMAJVER=`grep VERSION /etc/SuSE-release | sed -e 's/.*= //'`
	BRCMMINVER=`grep PATCHLEVEL /etc/SuSE-release | sed -e 's/.*= //'`
	if [ $BRCMMAJVER -eq 11 -a $BRCMMINVER -eq 1 ]; then
		BCM_CNIC="1"
		BCM_SCSI="1"
	fi
fi

if [ -d /lib/modules/$KVER/updates ]; then
	BCM_DIR=updates
elif [ -f /etc/depmod.conf ]; then
	if grep -q "search.*[[:space:]]updates" /etc/depmod.conf; then
		BCM_DIR=updates
	fi
fi

if [ -z "$BCM_DIR" -a -d /etc/depmod.d ]; then
	if grep -q "search.*[[:space:]]updates" /etc/depmod.d/*; then
		BCM_DIR=updates
	fi
fi

if [ -z "$BCM_DIR" ]; then
	BCM_DIR=kernel/drivers/net
fi

echo "%defattr(-,root,root)" > $RPM_BUILD_DIR/file.list.%{brcmname}
echo "/lib/modules/$KVER/$BCM_DIR/bnx2.${BCM_EXT}" >> $RPM_BUILD_DIR/file.list.%{brcmname}
echo "/lib/modules/$KVER/$BCM_DIR/bnx2x.${BCM_EXT}" >> $RPM_BUILD_DIR/file.list.%{brcmname}
mkdir -p $RPM_BUILD_ROOT/lib/modules/$KVER/$BCM_DIR

if [ "$BCM_CNIC" = "1" ]; then
	echo "/lib/modules/$KVER/$BCM_DIR/cnic.ko" >> $RPM_BUILD_DIR/file.list.%{brcmname}
fi

if [ "$BCM_SCSI" = "1" ]; then
	if [ -d /lib/modules/$KVER/updates ]; then
		BCM_SCSI_DIR=updates
	elif [ -f /etc/depmod.conf ]; then
		if grep -q "search.*[[:space:]]updates" /etc/depmod.conf; then
			BCM_SCSI_DIR=updates
		fi
	fi

	if [ -z "$BCM_SCSI_DIR" -a -d /etc/depmod.d ]; then
		if grep -q "search.*[[:space:]]updates" /etc/depmod.d/*; then
			BCM_SCSI_DIR=updates
		fi
	fi
	if [ -z "$BCM_SCSI_DIR" ]; then
		BCM_SCSI_DIR=kernel/drivers/scsi
	fi

	echo "/lib/modules/$KVER/$BCM_SCSI_DIR/bnx2i.${BCM_EXT}" >> $RPM_BUILD_DIR/file.list.%{brcmname}
	mkdir -p $RPM_BUILD_ROOT/lib/modules/$KVER/$BCM_SCSI_DIR
fi

echo "/usr/share/man/man4/bnx2.4.*"  >> $RPM_BUILD_DIR/file.list.%{brcmname}
echo "/usr/share/man/man4/bnx2x.4.*" >> $RPM_BUILD_DIR/file.list.%{brcmname}
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man4

make install KVER=$KVER PREFIX=$RPM_BUILD_ROOT
if [ "$RPM_BUILD_ROOT" != "/" ]; then
        rm -f $RPM_BUILD_ROOT/lib/modules/$KVER/modules.*
fi

if [ -d $RPM_BUILD_ROOT/lib/modules/$KVER/extra ]; then
	BCM_EXTRA_DIR=$RPM_BUILD_ROOT/lib/modules/$KVER/extra
	BCM_FINAL_DIR=$RPM_BUILD_ROOT/lib/modules/$KVER/${BCM_DIR}
	if [ "$BCM_SCSI" = "1" ]; then
		BCM_SCSI_FINAL_DIR=$RPM_BUILD_ROOT/lib/modules/$KVER/${BCM_SCSI_DIR}
	fi

	if [ -f ${BCM_EXTRA_DIR}/bnx2.${BCM_EXT} ]; then
		mv ${BCM_EXTRA_DIR}/bnx2.${BCM_EXT} ${BCM_FINAL_DIR}
	fi

	if [ -f ${BCM_EXTRA_DIR}/bnx2x.${BCM_EXT} ]; then
		mv ${BCM_EXTRA_DIR}/bnx2x.${BCM_EXT} ${BCM_FINAL_DIR}
	fi

	if [ -f ${BCM_EXTRA_DIR}/bnx2i.${BCM_EXT} ]; then
		mv ${BCM_EXTRA_DIR}/bnx2i.${BCM_EXT} ${BCM_SCSI_FINAL_DIR}
	fi

	if [ -f ${BCM_EXTRA_DIR}/cnic.ko ]; then
		mv ${BCM_EXTRA_DIR}/cnic.ko ${BCM_FINAL_DIR}
	fi

	if [ -z "`ls ${BCM_EXTRA_DIR}`" ]; then
		rmdir ${BCM_EXTRA_DIR}
	fi
fi

cp -f bnx2/LICENSE      .
cp -f bnx2/README.TXT   ./README.bnx2.TXT
cp -f bnx2/RELEASE.TXT  ./RELEASE.bnx2.TXT
cp -f bnx2x/README.TXT  ./README.bnx2x.TXT
cp -f bnx2x/RELEASE.TXT ./RELEASE.bnx2x.TXT
cp -f bnx2i/docs/README.TXT  ./README.bnx2i.TXT
cp -f bnx2i/docs/RELEASE.TXT ./RELEASE.bnx2i.TXT

%post
depmod -a > /dev/null 2> /dev/null
exit 0

%postun
depmod -a > /dev/null 2> /dev/null
exit 0

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{brcmname}

%files -f ../file.list.%{brcmname}
%doc LICENSE README.bnx2.TXT README.bnx2x.TXT README.bnx2i.TXT RELEASE.bnx2.TXT RELEASE.bnx2x.TXT RELEASE.bnx2i.TXT

%changelog
